#!/bin/sh

if [ `id -u` -gt 0 ]; then
	echo "You are not root"
	exit 1
fi

if [ $# -lt 1 ]; then
	echo "needs an argument"
	exit 1
fi

exec 2>/dev/null

case $1 in

	(-r):	# Read config
		TMPFILE=`mktemp /tmp/pf.conf.XXXXXXXXXX` || exit 1
		chown www $TMPFILE
		chmod 600 $TMPFILE
		cat /etc/pf.conf > $TMPFILE
		echo $TMPFILE
		;;

	(-t):	# Test Rulebase
		pfctl -n -f "$2" 2>&1
		OUT=$?
		rm -f "$2"
		exit $OUT
		;;

	(-i):	# Install Rulebase
		pfctl -n -f "$2" &&
		install -o root -m 0600 "$2" /etc/pf.conf &&
		pfctl -f /etc/pf.conf
		OUT=$?
		rm -f "$2"
		exit $OUT
		;;

esac
