<?php
/*
 * Copyright (c) 2004 Allard Consulting.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgement: This
 *    product includes software developed by Allard Consulting
 *    and its contributors.
 * 4. Neither the name of Allard Consulting nor the names of
 *    its contributors may be used to endorse or promote products
 *    derived from this software without specific prior written
 *    permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

$inst_dir = realpath("..");

/**
* Releads the current page. This is done to clean up the url after some
* variables has been passed and it's undesireble for the user to resubmit
* the changes through a page reload.
*
* @return void
*/
function reload($url = false)
{
	if (isset($_GET['rulenumber']) && !$url) {
	  $url = "?rulenumber=". $_GET['rulenumber'];
	}
	header("location: ".  $_SERVER['PHP_SELF']. $url);
}

/**
* Displayes the page header
*
* @param string $title The page title.
* @return string The page header output ready for printing.
*/
function page_header ($title)
{
	$return  =  "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.1//EN\"\n";
	$return .=  "\t\"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd\">\n";
	$return .=  "<html>\n";
	$return .=  "<head>\n";
	if (preg_match("/| pfw/", $title)) {
		$return .=  "\t<title>$title</title>\n";
	} else {
		$return .=  "\t<title>$title | pfw</title>\n";	
	}
	$return .=  "\t<style type=\"text/css\" media=\"screen\">@import url(screen.css);</style>\n";
	$return .=  "\t<style type=\"text/css\" media=\"print\">@import url(print.css);</style>\n";
	$return .=  "</head>\n";
	print $return;
}

require_once ("$inst_dir/lib/rules.class.php");
require_once ("$inst_dir/lib/pf.class.php");
require_once ("$inst_dir/lib/filter.class.php");
require_once ("$inst_dir/lib/nat.class.php");
require_once ("$inst_dir/lib/macro.class.php");
require_once ("$inst_dir/lib/scrub.class.php");
require_once ("$inst_dir/lib/table.class.php");
require_once ("$inst_dir/lib/altq.class.php");
require_once ("$inst_dir/lib/queue.class.php");
require_once ("$inst_dir/lib/options.class.php");
require_once ("$inst_dir/lib/anchor.class.php");

session_name("pfw_session");
session_start();

if (isset($_GET['reset'])) {
	unset ($_SESSION['pf']);
	reload();
}

if (!isset($_SESSION['pf'])) {
	$_SESSION['pf'] = new pf ();
	$filename = exec ("sudo $inst_dir/bin/pfctlwrapper.sh -r");
	$_SESSION['pf']->parseRulebase (file_get_contents($filename));
	unlink ($filename);
}

if (!isset($_SESSION['edit'])) {
	$_SESSION['edit'] = array();
}
?>